package com.docus.soap.api;

import org.springframework.context.annotation.AdviceMode;
import org.springframework.context.annotation.Import;

import java.lang.annotation.*;

@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Import(EnableSoapAPIClientSelector.class)
@Inherited
public @interface EnableSoapAPIClient {
    AdviceMode mode() default AdviceMode.PROXY;
}
